'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var mlCart = require('ml-cart');
var mlRandomForest = require('ml-random-forest');
var mlPca = require('ml-pca');
var mlHclust = require('ml-hclust');
var mlKmeans = _interopDefault(require('ml-kmeans'));
var mlNaivebayes = require('ml-naivebayes');
var mlKnn = _interopDefault(require('ml-knn'));
var mlPls = require('ml-pls');
var mlCrossValidation = _interopDefault(require('ml-cross-validation'));
var mlConfusionMatrix = _interopDefault(require('ml-confusion-matrix'));
var mlFnn = _interopDefault(require('ml-fnn'));
var mlSom = _interopDefault(require('ml-som'));
var mlRegression = require('ml-regression');
var mlLevenbergMarquardt = _interopDefault(require('ml-levenberg-marquardt'));
var MatrixLib = require('ml-matrix');
var mlSparseMatrix = require('ml-sparse-matrix');
var mlKernel = _interopDefault(require('ml-kernel'));
var mlDistance = require('ml-distance');
var mlDistanceMatrix = _interopDefault(require('ml-distance-matrix'));
var mlXsadd = _interopDefault(require('ml-xsadd'));
var mlPerformance = _interopDefault(require('ml-performance'));
var mlSavitzkyGolay = _interopDefault(require('ml-savitzky-golay'));
var mlBitArray = _interopDefault(require('ml-bit-array'));
var mlHashTable = _interopDefault(require('ml-hash-table'));
var mlPadArray = _interopDefault(require('ml-pad-array'));
var binarySearch = _interopDefault(require('binary-search'));
var numSort = require('num-sort');
var mlRandom = _interopDefault(require('ml-random'));
var min = _interopDefault(require('ml-array-min'));
var max = _interopDefault(require('ml-array-max'));
var median = _interopDefault(require('ml-array-median'));
var mean = _interopDefault(require('ml-array-mean'));
var mode = _interopDefault(require('ml-array-mode'));
var normed = _interopDefault(require('ml-array-normed'));
var rescale = _interopDefault(require('ml-array-rescale'));
var sequentialFill = _interopDefault(require('ml-array-sequential-fill'));
var standardDeviation = _interopDefault(require('ml-array-standard-deviation'));
var variance = _interopDefault(require('ml-array-variance'));
var centroidsMerge = _interopDefault(require('ml-array-xy-centroids-merge'));
var closestX = _interopDefault(require('ml-arrayxy-closestx'));
var maxMerge = _interopDefault(require('ml-array-xy-max-merge'));
var maxY = _interopDefault(require('ml-array-xy-max-y'));
var sortX = _interopDefault(require('ml-array-xy-sort-x'));
var uniqueX = _interopDefault(require('ml-arrayxy-uniquex'));
var weightedMerge = _interopDefault(require('ml-array-xy-weighted-merge'));
var equallySpaced = _interopDefault(require('ml-array-xy-equally-spaced'));
var filterX = _interopDefault(require('ml-array-xy-filter-x'));

const {
  Matrix,
  SVD,
  EVD,
  CholeskyDecomposition,
  LuDecomposition,
  QrDecomposition
} = MatrixLib;
const Array = {
  min,
  max,
  median,
  mean,
  mode,
  normed,
  rescale,
  sequentialFill,
  standardDeviation,
  variance
};
const ArrayXY = {
  centroidsMerge,
  closestX,
  maxMerge,
  maxY,
  sortX,
  uniqueX,
  weightedMerge,
  equallySpaced,
  filterX
};

Object.defineProperty(exports, 'DecisionTreeClassifier', {
  enumerable: true,
  get: function () {
    return mlCart.DecisionTreeClassifier;
  }
});
Object.defineProperty(exports, 'DecisionTreeRegression', {
  enumerable: true,
  get: function () {
    return mlCart.DecisionTreeRegression;
  }
});
Object.defineProperty(exports, 'RandomForestClassifier', {
  enumerable: true,
  get: function () {
    return mlRandomForest.RandomForestClassifier;
  }
});
Object.defineProperty(exports, 'RandomForestRegression', {
  enumerable: true,
  get: function () {
    return mlRandomForest.RandomForestRegression;
  }
});
Object.defineProperty(exports, 'PCA', {
  enumerable: true,
  get: function () {
    return mlPca.PCA;
  }
});
exports.HClust = mlHclust;
exports.KMeans = mlKmeans;
exports.NaiveBayes = mlNaivebayes;
exports.KNN = mlKnn;
Object.defineProperty(exports, 'KOPLS', {
  enumerable: true,
  get: function () {
    return mlPls.KOPLS;
  }
});
Object.defineProperty(exports, 'PLS', {
  enumerable: true,
  get: function () {
    return mlPls.PLS;
  }
});
exports.CrossValidation = mlCrossValidation;
exports.ConfusionMatrix = mlConfusionMatrix;
exports.FNN = mlFnn;
exports.SOM = mlSom;
Object.defineProperty(exports, 'ExponentialRegression', {
  enumerable: true,
  get: function () {
    return mlRegression.ExponentialRegression;
  }
});
Object.defineProperty(exports, 'MultivariateLinearRegression', {
  enumerable: true,
  get: function () {
    return mlRegression.MultivariateLinearRegression;
  }
});
Object.defineProperty(exports, 'PolynomialRegression', {
  enumerable: true,
  get: function () {
    return mlRegression.PolynomialRegression;
  }
});
Object.defineProperty(exports, 'PowerRegression', {
  enumerable: true,
  get: function () {
    return mlRegression.PowerRegression;
  }
});
Object.defineProperty(exports, 'RobustPolynomialRegression', {
  enumerable: true,
  get: function () {
    return mlRegression.RobustPolynomialRegression;
  }
});
Object.defineProperty(exports, 'SimpleLinearRegression', {
  enumerable: true,
  get: function () {
    return mlRegression.SimpleLinearRegression;
  }
});
Object.defineProperty(exports, 'TheilSenRegression', {
  enumerable: true,
  get: function () {
    return mlRegression.TheilSenRegression;
  }
});
exports.levenbergMarquardt = mlLevenbergMarquardt;
exports.MatrixLib = MatrixLib;
Object.defineProperty(exports, 'SparseMatrix', {
  enumerable: true,
  get: function () {
    return mlSparseMatrix.SparseMatrix;
  }
});
exports.Kernel = mlKernel;
Object.defineProperty(exports, 'Distance', {
  enumerable: true,
  get: function () {
    return mlDistance.distance;
  }
});
Object.defineProperty(exports, 'Similarity', {
  enumerable: true,
  get: function () {
    return mlDistance.similarity;
  }
});
exports.distanceMatrix = mlDistanceMatrix;
exports.XSadd = mlXsadd;
exports.Performance = mlPerformance;
exports.savitzkyGolay = mlSavitzkyGolay;
exports.BitArray = mlBitArray;
exports.HashTable = mlHashTable;
exports.padArray = mlPadArray;
exports.binarySearch = binarySearch;
exports.numSort = numSort;
exports.Random = mlRandom;
exports.Array = Array;
exports.ArrayXY = ArrayXY;
exports.CholeskyDecomposition = CholeskyDecomposition;
exports.EVD = EVD;
exports.LuDecomposition = LuDecomposition;
exports.Matrix = Matrix;
exports.QrDecomposition = QrDecomposition;
exports.SVD = SVD;
